/*
 * Copyright (c) 2006 The Trustees of Indiana University and Indiana
 *                    University Research and Technology
 *                    Corporation.  All rights reserved.
 * Copyright (c) 2006 The Technical University of Chemnitz. All 
 *                    rights reserved.
 *
 * Author(s): (alphabetically)
 *            Sven Eckelmann
 *            Torsten Hoefler 
 *            Mirko Reinhard 
 *            Matthias Treydte 
 */

#ifndef ENET_STREAM_OUTPUT_H_
#define ENET_STREAM_OUTPUT_H_

#include "enet_stream.h"
#include "enet_stream_cong.h"

int esp_skb_xmit(struct sock *sk, struct sk_buff *skb);

int sock_esp_sendmsg(struct kiocb *iocb, struct socket *sock,
                     struct msghdr *msg, size_t len);

int esp_send_ack(struct sock *sk);
int esp_send_rrq(struct sock *sk);
int esp_send_fin(struct sock *sk, gfp_t allocation);
int esp_send_syn(struct sock *sk, struct net_device *dev, gfp_t allocation);
int esp_send_rst(struct sk_buff *src_skb);
int esp_push_one_frame(struct sock *sk, int fix_empty_sbuff);
int esp_push_pending_frames(struct sock *sk);
int esp_enqueue_ack(struct sock *sk, int flags);

/**
 * TODO: Tests if its ok to ACK with an data packet.
 */
static inline int esp_test_prepare_fastack(struct sock *sk)
{
	return 0;
}

#endif /* ENET_STREAM_OUTPUT_H_ */
